package question1;


public class And<T> extends CompositeSpecification<T> {
    
    public boolean isSatisfiedBy(T t) {
        boolean res = true;
        for(Specification<T> spec : this) {
            res &= spec.isSatisfiedBy(t); 
        }
        return res;
    }
    
    public String interpreter() {
        return "and"+super.interpreter();
    }

}
