package question1;


public class OnlyOne<T> extends CompositeSpecification<T> {
    
    public boolean isSatisfiedBy(T t) {
        int res = 0;
        for(Specification<T> spec : this) {
            if(spec.isSatisfiedBy(t))
                res ++; 
        }
        return res==1;
    }
    
    public String interpreter() {
        return "none"+super.interpreter();
    }

}
