package question2;

public class MacroCommandException<R> extends MacroCommand<R> {

    private Command<R> commException;

    public void setExceptionCmd(Command<R> commException) {
        this.commException=commException;
    }

    public R execute(R r) throws Exception{
        try {
            for(Command<R> cmd : this){
             r = cmd.execute(r);
          }
        } catch (Exception e) {
            return commException.execute(r);
        }
        return r;
    }

}
