package question4;

import question3.*;
import question2.*;
import question1.*;

public class TestsTraceRule extends junit.framework.TestCase {

    public void testTraceRule() throws Exception{

        Specification<Integer> inf = new EstInferieur(4);
        MacroCommand<Integer> plus2 = new MacroCommand<Integer>();
        plus2.add(new Inc()).add(new Inc());

        RuleI<Integer,Integer> rule = new SautDeLigneRule (new TraceRule (new Rule<>(inf,plus2)));

        //rule = cf. question 4-3

        Integer res = 0, x = 3;

        res = rule.execute(x,res); // 
        assertEquals(new Integer(2),res);   // [res==2]

        Integer res1 = rule.execute(5,res); // 
        assertEquals(new Integer(2), res1); // [res==2]
        ClusterRules<Integer,Integer> cluster = new ClusterRules("cluster");
        cluster.add(rule).add(rule).add(rule);

        Integer res2 = cluster.execute(2,0);
        assertEquals(new Integer(6),res2);
        System.out.println();
    }

    public void testTraceResultRuleTraceRule() throws Exception{

        Specification<Integer> inf = new EstInferieur(4);
        MacroCommand<Integer> plus2 = new MacroCommand<Integer>();
        plus2.add(new Inc()).add(new Inc());

        RuleI<Integer,Integer> rule = new TraceResultRule(new TraceRule (new Rule<>(inf,plus2)));

        //rule = cf. question 4-3

        Integer res = 0, x = 3;

        res = rule.execute(x,res); // 
        assertEquals(new Integer(2),res);   // [res==2]

        Integer res1 = rule.execute(5,res); // 
        assertEquals(new Integer(2), res1); // [res==2]
        ClusterRules<Integer,Integer> cluster = new ClusterRules("cluster");
        cluster.add(rule).add(rule).add(rule);

        Integer res2 = cluster.execute(2,0);
        assertEquals(new Integer(6),res2);
    }
}
