package question1;

public class Not<T> extends Specification<T> {
    
    Specification <T> spec;
    
    public Not(Specification <T> spec) {
        this.spec=spec;
    }
    
    public boolean isSatisfiedBy(T t) {
        return ! this.spec.isSatisfiedBy(t);
    }
    
    public String interpreter() {
        return "not("+spec.interpreter()+")";
    }
}
