package question1;


public class Or<T> extends CompositeSpecification<T> {
    
    public boolean isSatisfiedBy(T t) {
        boolean res = false;
        for(Specification<T> spec : this) {
            res |= spec.isSatisfiedBy(t); 
        }
        return res;
    }
    
    public String interpreter() {
        return "or"+super.interpreter();
    }

}
