package question4;

import question3.*;
import question2.*;
import question1.*;

public class TraceResultRule<E,R> extends DecoratorRule<E,R> {
   
    public TraceResultRule (RuleI<E,R> rule) { 
        super(rule);
    }
    
     public R execute(E e, R r) throws Exception {
         System.out.print("<e:"+e+",r:"+r+">");
         R r2 = getRule().execute(e,r);
         System.out.print("<e:"+e+",r:"+r2+">\n");
         return r2;
        }
}
