package question4;

import question3.*;
import question2.*;
import question1.*;

public class TraceRule<E,R> extends DecoratorRule<E,R> {
   
    public TraceRule (RuleI<E,R> rule) { 
        super(rule);
    }
    
     public R execute(E e, R r) throws Exception {
         System.out.print("\tif("+e+" "+getRule().getSpecification().interpreter()+")then");
         System.out.print(getRule().getCommand().interpreter()+";");
         return getRule().execute(e,r);
        }
}
